﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.ComponentModel.DataAnnotations;
using MvcEFCodeFirst.Data;

namespace MvcEFCodeFirst.Data
{
  [AttributeUsage(AttributeTargets.Property, AllowMultiple = false)]
  public class AdvancedEmailValidationAttribute : ValidationAttribute
  {
    protected override ValidationResult IsValid(object value, ValidationContext validationContext)
    {
      IPersonWithEmail objectToValidate = validationContext.ObjectInstance as IPersonWithEmail;
      ValidationResult returnValue = ValidationResult.Success;
      
      if (objectToValidate != null)
      {
        if (value != null)
        {
          if (
            value.ToString().ToUpper().Contains(objectToValidate.LastName.ToUpper()) ||
            value.ToString().ToUpper().Contains(objectToValidate.LastName.ToUpper()))
          {
            returnValue = new ValidationResult(string.Format("Email ({0}) cannot contain first ({1}) or last ({2}) name",
              value.ToString(), objectToValidate.FirstName, objectToValidate.LastName));
          }
        }
      }
      else
      {
        returnValue = new ValidationResult("You must implement IPersonWithEmail on your object to use this rule");
      }
      return returnValue;
    }
  }
}