﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using MvcEFCodeFirst.Resources;

namespace MvcEFCodeFirst.Data
{
  public class Session
  {
    [Key]
    public int SessionID { get; set; }

    [StringLength(30, 
      ErrorMessageResourceName = "Title30Characters", 
      ErrorMessageResourceType = typeof(Resource))]
    [Required(
      ErrorMessageResourceName = "TitleRequired",
      ErrorMessageResourceType = typeof(Resource))]
    [Display(Name = "Title", ResourceType = typeof(Resource))]
    public string Title { get; set; }

    [Required(
      ErrorMessageResourceName = "SessionDateRequired",
      ErrorMessageResourceType = typeof(Resource))]
    [Display(Name = "SessionDate", ResourceType = typeof(Resource))]
    [DataType(DataType.DateTime,
      ErrorMessageResourceName = "SessionDateInvalid",
      ErrorMessageResourceType = typeof(Resource))]
    public DateTime? SessionDate { get; set; }

    [StringLength(int.MaxValue)]
    [Required(
     ErrorMessageResourceName = "DescriptionRequired",
     ErrorMessageResourceType = typeof(Resource))]
    [Display(Name = "Description", ResourceType = typeof(Resource))]
    public string Description { get; set; }

    [Required(
      ErrorMessageResourceName = "CategoryRequired",
      ErrorMessageResourceType = typeof(Resource))]
    [Display(Name = "Category", ResourceType = typeof(Resource))]
    public int SessionCategoryID { get; set; }

    [ForeignKey("SessionCategoryID")]
    public virtual SessionCategory SessionCategory { get; set; }

    public virtual ICollection<Attendee> Attendees { get; set; }
  }
}
