﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.Entity;
using System.Linq.Expressions;

namespace MvcEFCodeFirst.DataAccess
{
  public interface IRepository : IDisposable
  {

    void Delete<TItem>(TItem item) where TItem : class, new();

    TItem Insert<TItem>(TItem item) where TItem : class, new();

    IQueryable<TItem> Select<TItem>() where TItem : class, new();

    TItem Update<TItem>(TItem item) where TItem : class, new();

    TItem Find<TItem>(params object[] keyValues) where TItem : class, new();

    void SetModified(object item);

    void Save();
  }
}
