﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using MvcEFCodeFirst.DataAccess;
using MvcEFCodeFirst.Data;
using System.Web.Caching;

namespace MvcEFCodeFirst.Models
{
  public class LookupModel
  {
    private CodeStockContext db = new CodeStockContext();

    private static Dictionary<string, object> cache = new Dictionary<string, object>();

    public IEnumerable<SessionCategory> Categories
    {
      get
      {
        if (cache.ContainsKey("Categories"))
        {
          return cache["Categories"] as IEnumerable<SessionCategory>;
        }
        else
        {
          var categories = db.SessionCategories.OrderBy(c => c.SessionCategoryName).ToList();
          cache["Categories"] = categories;
          return categories;
        }
      }
    }
  }
}